#***************************************************************************
#*
#**  File     :  /lua/ai/AIEconomicBuilders.lua
#**
#**  Summary  : Default economic builders for skirmish
#**
#**  Copyright  2005 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************

local BBTmplFile = '/lua/basetemplates.lua'
local BuildingTmpl = 'BuildingTemplates'
local BaseTmpl = 'BaseTemplates'
local ExBaseTmpl = 'ExpansionBaseTemplates'
local Adj2x2Tmpl = 'Adjacency2x2'
local UCBC = '/lua/editor/UnitCountBuildConditions.lua'
local MIBC = '/lua/editor/MiscBuildConditions.lua'
local MABC = '/lua/editor/MarkerBuildConditions.lua'
local IBC = '/lua/editor/InstantBuildConditions.lua'
local OAUBC = '/lua/editor/OtherArmyUnitCountBuildConditions.lua'
local EBC = '/lua/editor/EconomyBuildConditions.lua'
local PCBC = '/lua/editor/PlatoonCountBuildConditions.lua'
local SAI = '/lua/ScenarioPlatoonAI.lua'
local TBC = '/lua/editor/ThreatBuildConditions.lua'
local PlatoonFile = '/lua/platoon.lua'
local UC = '/Mods/Commanders Revenges FA UEF,Cybran,Aeon,Seraphim/hook/lua/UpgradeConditions.lua'


BuilderGroup {
    BuilderGroupName = 'ACUUpgrades',
    BuildersType = 'PlatoonFormBuilder',
   
####UEF
   #LCH:
   Builder {
        BuilderName = 'UEF CDR HeavyBolterLUpgrade',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 2000,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'HeavyBolterLUpgrade' }},
                { MIBC, 'FactionIndex', {1, 1}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'HeavyBolterLUpgrade' },
        },
    },
    Builder {
        BuilderName = 'UEF CDR AdvancedEngineering',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1900,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'AdvancedEngineering' }},
                { MIBC, 'FactionIndex', {1, 1}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'AdvancedEngineering' },
        },
    },
    Builder {
        BuilderName = 'UEF CDR HeavyOverMegaCanonLUpgrade',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1800,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'HeavyOverMegaCanonLUpgrade' }},
                { MIBC, 'FactionIndex', {1, 1}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'HeavyOverMegaCanonLUpgrade' },
        },
    },
    Builder {
        BuilderName = 'UEF CDR T3Engineering',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1700,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'T3Engineering' }},
                { MIBC, 'FactionIndex', {1, 1}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'T3Engineering' },
        },
    },
    Builder {
        BuilderName = 'UEF CDR T4Engineering',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1600,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'T4Engineering' }},
                { MIBC, 'FactionIndex', {1, 1}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'T4Engineering' },
        },
    },
    Builder {
        BuilderName = 'UEF CDR HeavyAntiAirLUpgrade',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1500,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'HeavyAntiAirLUpgrade' }},
                { MIBC, 'FactionIndex', {1, 1}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'HeavyAntiAirLUpgrade' },
        },
    },
    Builder {
        BuilderName = 'UEF CDR LeftMinigun',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1400,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'LeftMinigun' }},
                { MIBC, 'FactionIndex', {1, 1}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'LeftMinigun' },
        },
    },
    Builder {
        BuilderName = 'UEF CDR LeftPod',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1300,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'LeftPod' }},
                { MIBC, 'FactionIndex', {1, 1}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'LeftPod' },
        },
    },
   #Back:
    Builder {
        BuilderName = 'UEF CDR Shield',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 2000,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'Shield' }},
                { MIBC, 'FactionIndex', {1, 1}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'Shield' },
        },
    },
    Builder {
        BuilderName = 'UEF CDR ShieldGeneratorField',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1900,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'ShieldGeneratorField' }},
                { MIBC, 'FactionIndex', {1, 1}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'ShieldGeneratorField' },
        },
    },
   	Builder {
        BuilderName = 'UEF CDR DamageStablization',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1800,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'DamageStablization' }},
                { MIBC, 'FactionIndex', {1, 1}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'DamageStablization' },
        },
    },
    Builder {
        BuilderName = 'UEF CDR Health',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1700,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'Health' }},
                { MIBC, 'FactionIndex', {1, 1}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'Health' },
        },
    },
    Builder {
        BuilderName = 'UEF CDR Teleporter',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1600,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'Teleporter' }},
                { MIBC, 'FactionIndex', {1, 1}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'Teleporter' },
        },
    },
   #Right:
    Builder {
        BuilderName = 'UEF CDR HeavyBolterRUpgrade',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 2000,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'HeavyBolterRUpgrade' }},
                { MIBC, 'FactionIndex', {1, 1}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'HeavyBolterRUpgrade' },
        },
    },
    Builder {
        BuilderName = 'UEF CDR ResourceAllocationI',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1900,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'ResourceAllocationI' }},
                { MIBC, 'FactionIndex', {1, 1}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'ResourceAllocationI' },
        },
    },
    Builder {
        BuilderName = 'UEF CDR HeavyOverMegaCanonRUpgrade',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1800,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'HeavyOverMegaCanonRUpgrade' }},
                { MIBC, 'FactionIndex', {1, 1}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'HeavyOverMegaCanonRUpgrade' },
        },
    },
    Builder {
        BuilderName = 'UEF CDR ResourceAllocationII',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1700,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'ResourceAllocationII' }},
                { MIBC, 'FactionIndex', {1, 1}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'ResourceAllocationII' },
        },
    },
    Builder {
        BuilderName = 'UEF CDR HeavyAntiAirRUpgrade',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1600,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'HeavyAntiAirRUpgrade' }},
                { MIBC, 'FactionIndex', {1, 1}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'HeavyAntiAirRUpgrade' },
        },
    },
    Builder {
        BuilderName = 'UEF CDR RightMinigun',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1500,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'RightMinigun' }},
                { MIBC, 'FactionIndex', {1, 1}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'RightMinigun' },
        },
    },
    Builder {
        BuilderName = 'UEF CDR RightPod',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1400,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'RightPod' }},
                { MIBC, 'FactionIndex', {1, 1}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'RightPod' },
        },
    },
    
###Aeon
   #LCH: 
    Builder {
        BuilderName = 'Aeon CDR LeftDisruptor',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 2000,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'LeftDisruptor' }},
                { MIBC, 'FactionIndex', {2, 2}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'LeftDisruptor' },
        },
    },
    Builder {
        BuilderName = 'Aeon CDR AdvancedEngineering',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1900,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'AdvancedEngineering' }},
                { MIBC, 'FactionIndex', {2, 2}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'AdvancedEngineering' },
        },
    },
    Builder {
        BuilderName = 'Aeon CDR LeftQuantum',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1800,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'LeftQuantum' }},
                { MIBC, 'FactionIndex', {2, 2}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'LeftQuantum' },
        },
    },
    Builder {
        BuilderName = 'Aeon CDR LeftAntiair',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1700,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'LeftAntiair' }},
                { MIBC, 'FactionIndex', {2, 2}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'LeftAntiair' },
        },
    },
    Builder {
        BuilderName = 'Aeon CDR T3Engineering',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1600,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'T3Engineering' }},
                { MIBC, 'FactionIndex', {2, 2}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'T3Engineering' },
        },
    },
    Builder {
        BuilderName = 'Aeon CDR T4Engineering',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1500,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'T4Engineering' }},
                { MIBC, 'FactionIndex', {2, 2}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'T4Engineering' },
        },
    },
    Builder {
        BuilderName = 'Aeon CDR MultiMissile',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1400,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'MultiMissile' }},
                { MIBC, 'FactionIndex', {2, 2}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'MultiMissile' },
        },
    },
   #Back:
    Builder {
        BuilderName = 'Aeon CDR Shield',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 2000,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'Shield' }},
                { MIBC, 'FactionIndex', {2, 2}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'Shield' },
        },
    },
    Builder {
        BuilderName = 'Aeon CDR ResourceAllocation',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1900,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'ResourceAllocation' }},
                { MIBC, 'FactionIndex', {2, 2}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'ResourceAllocation' },
        },
    },
    Builder {
        BuilderName = 'Aeon CDR ChronoDampener',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1800,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'ChronoDampener' }},
                { MIBC, 'FactionIndex', {2, 2}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'ChronoDampener' },
        },
    },
    Builder {
        BuilderName = 'Aeon CDR ShieldHeavy',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1700,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'ShieldHeavy' }},
                { MIBC, 'FactionIndex', {2, 2}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'ShieldHeavy' },
        },
    },
    Builder {
        BuilderName = 'Aeon CDR ResourceAllocationAdvanced',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1600,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'ResourceAllocationAdvanced' }},
                { MIBC, 'FactionIndex', {2, 2}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'ResourceAllocationAdvanced' },
        },
    },
    Builder {
        BuilderName = 'Aeon CDR AdvanceChronoDampener',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1500,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'AdvanceChronoDampener' }},
                { MIBC, 'FactionIndex', {2, 2}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'AdvanceChronoDampener' },
        },
    },
   	Builder {
        BuilderName = 'Aeon CDR Teleporter',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1400,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'Teleporter' }},
                { MIBC, 'FactionIndex', {2, 2}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'Teleporter' },
        },
    },
   #Right:
   	Builder {
        BuilderName = 'Aeon CDR CrysalisBeam',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 2000,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'CrysalisBeam' }},
                { MIBC, 'FactionIndex', {2, 2}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'CrysalisBeam' },
        },
    },
    Builder {
        BuilderName = 'Aeon CDR EnhancedSensors',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1900,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'EnhancedSensors' }},
                { MIBC, 'FactionIndex', {2, 2}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'EnhancedSensors' },
        },
    },
    Builder {
        BuilderName = 'Aeon CDR HeatSink',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1800,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'HeatSink' }},
                { MIBC, 'FactionIndex', {2, 2}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'HeatSink' },
        },
    },
    Builder {
        BuilderName = 'Aeon CDR RightAntiair',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1700,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'RightAntiair' }},
                { MIBC, 'FactionIndex', {2, 2}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'RightAntiair' },
        },
    },
    Builder {
        BuilderName = 'Aeon CDR QuantumCooler',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1600,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'QuantumCooler' }},
                { MIBC, 'FactionIndex', {2, 2}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'QuantumCooler' },
        },
    },
    Builder {
        BuilderName = 'Aeon CDR OblivionGun',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1500,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'OblivionGun' }},
                { MIBC, 'FactionIndex', {2, 2}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'OblivionGun' },
        },
    },
####Cybran
  	#Left
  	Builder {
        BuilderName = 'Cybran CDR CoolingUpgrade',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 2000,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'CoolingUpgrade' }},
                { MIBC, 'FactionIndex', {3, 3}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'CoolingUpgrade' },
        },
    },
    Builder {
        BuilderName = 'Cybran CDR AdvancedEngineering',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1900,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'AdvancedEngineering' }},
                { MIBC, 'FactionIndex', {3, 3}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'AdvancedEngineering' },
        },
    },
    Builder {
        BuilderName = 'Cybran CDR ImprovedRipper',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1800,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'ImprovedRipper' }},
                { MIBC, 'FactionIndex', {3, 3}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'ImprovedRipper' },
        },
    },
    Builder {
        BuilderName = 'Cybran CDR T3Engineering',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1700,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'T3Engineering' }},
                { MIBC, 'FactionIndex', {3, 3}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'T3Engineering' },
        },
    },
    Builder {
        BuilderName = 'Cybran CDR T4Engineering',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1600,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'T4Engineering' }},
                { MIBC, 'FactionIndex', {3, 3}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'T4Engineering' },
        },
    },
    Builder {
        BuilderName = 'Cybran CDR BigArmor',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1500,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'BigArmor' }},
                { MIBC, 'FactionIndex', {3, 3}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'BigArmor' },
        },
    },
    #Back
    Builder {
        BuilderName = 'Cybran CDR StealthGenerator',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 2000,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'StealthGenerator' }},
                { MIBC, 'FactionIndex', {3, 3}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'StealthGenerator' },
        },
    },
    Builder {
        BuilderName = 'Cybran CDR ResourceAllocation',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1900,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'ResourceAllocation' }},
                { MIBC, 'FactionIndex', {3, 3}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'ResourceAllocation' },
        },
    },
    Builder {
        BuilderName = 'Cybran CDR CloakingGenerator',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1800,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'CloakingGenerator' }},
                { MIBC, 'FactionIndex', {3, 3}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'CloakingGenerator' },
        },
    },
    Builder {
        BuilderName = 'Cybran CDR Bullseye',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1700,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'Bullseye' }},
                { MIBC, 'FactionIndex', {3, 3}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'Bullseye' },
        },
    },
    Builder {
        BuilderName = 'Cybran CDR AntiMissile',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1600,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'AntiMissile' }},
                { MIBC, 'FactionIndex', {3, 3}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'AntiMissile' },
        },
    },
    Builder {
        BuilderName = 'Cybran CDR Teleporter',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1500,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'Teleporter' }},
                { MIBC, 'FactionIndex', {3, 3}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'Teleporter' },
        },
    },
    #Right
    Builder {
        BuilderName = 'Cybran CDR RRipper',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 2000,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'RRipper' }},
                { MIBC, 'FactionIndex', {3, 3}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'RRipper' },
        },
    },
    Builder {
        BuilderName = 'Cybran CDR NaniteTorpedoTube',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1900,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'NaniteTorpedoTube' }},
                { MIBC, 'FactionIndex', {3, 3}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'NaniteTorpedoTube' },
        },
    },
    Builder {
        BuilderName = 'Cybran CDR MicrowaveLaserGenerator',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1800,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'MicrowaveLaserGenerator' }},
                { MIBC, 'FactionIndex', {3, 3}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'MicrowaveLaserGenerator' },
        },
    },
    Builder {
        BuilderName = 'Cybran CDR AntiAir',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1700,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'AntiAir' }},
                { MIBC, 'FactionIndex', {3, 3}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'AntiAir' },
        },
    },
    Builder {
        BuilderName = 'Cybran CDR Artillery',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1600,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'Artillery' }},
                { MIBC, 'FactionIndex', {3, 3}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'Artillery' },
        },
    },
####Seraphim
		#Left
		Builder {
        BuilderName = 'Seraphim CDR BlastAttack',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 2000,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'BlastAttack' }},
                { MIBC, 'FactionIndex', {4, 4}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'BlastAttack' },
        },
    },
		Builder {
        BuilderName = 'Seraphim CDR AdvancedEngineering',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1900,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'AdvancedEngineering' }},
                { MIBC, 'FactionIndex', {4, 4}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'AdvancedEngineering' },
        },
    },
		Builder {
        BuilderName = 'Seraphim CDR MultiGun',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1800,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'MultiGun' }},
                { MIBC, 'FactionIndex', {4, 4}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'MultiGun' },
        },
    },
		Builder {
        BuilderName = 'Seraphim CDR T3Engineering',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1700,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'T3Engineering' }},
                { MIBC, 'FactionIndex', {4, 4}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'T3Engineering' },
        },
    },
		Builder {
        BuilderName = 'Seraphim CDR T4Engineering',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1600,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'T4Engineering' }},
                { MIBC, 'FactionIndex', {4, 4}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'T4Engineering' },
        },
    },
    #Back
    Builder {
        BuilderName = 'Seraphim CDR ResourceAllocation',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 2000,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'ResourceAllocation' }},
                { MIBC, 'FactionIndex', {4, 4}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'ResourceAllocation' },
        },
    },
		Builder {
        BuilderName = 'Seraphim CDR DamageStabilization',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1900,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'DamageStabilization' }},
                { MIBC, 'FactionIndex', {4, 4}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'DamageStabilization' },
        },
    },
		Builder {
        BuilderName = 'Seraphim CDR ResourceAllocationAdvanced',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1800,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'ResourceAllocationAdvanced' }},
                { MIBC, 'FactionIndex', {4, 4}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'ResourceAllocationAdvanced' },
        },
    },
		Builder {
        BuilderName = 'Seraphim CDR DamageStabilizationAdvanced',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1700,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'DamageStabilizationAdvanced' }},
                { MIBC, 'FactionIndex', {4, 4}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'DamageStabilizationAdvanced' },
        },
    },
		Builder {
        BuilderName = 'Seraphim CDR Teleporter',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1600,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'Teleporter' }},
                { MIBC, 'FactionIndex', {4, 4}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'Teleporter' },
        },
    },
		#Right
		Builder {
        BuilderName = 'Seraphim CDR RegenAura',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 2000,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'RegenAura' }},
                { MIBC, 'FactionIndex', {4, 4}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'RegenAura' },
        },
    },
    Builder {
        BuilderName = 'Seraphim CDR RateOfFire',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1900,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'RateOfFire' }},
                { MIBC, 'FactionIndex', {4, 4}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'RateOfFire' },
        },
    },
		Builder {
        BuilderName = 'Seraphim CDR AdvancedRegenAura',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1800,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'AdvancedRegenAura' }},
                { MIBC, 'FactionIndex', {4, 4}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'AdvancedRegenAura' },
        },
    },
		Builder {
        BuilderName = 'Seraphim CDR Antiair',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1700,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'Antiair' }},
                { MIBC, 'FactionIndex', {4, 4}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'Antiair' },
        },
    },
		Builder {
        BuilderName = 'Seraphim CDR Electrobolter',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1600,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'Electrobolter' }},
                { MIBC, 'FactionIndex', {4, 4}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'Electrobolter' },
        },
    },
		Builder {
        BuilderName = 'Seraphim CDR AdvanceAntiair',
        PlatoonTemplate = 'CommanderEnhance',
		Priority = 1500,
        BuilderConditions = {
                { UCBC, 'HaveGreaterThanUnitsWithCategory', { 1, 'FACTORY' }},
                { UC, 'CanUpgrade', { 'AdvanceAntiair' }},
                { MIBC, 'FactionIndex', {4, 4}},
            },
        PlatoonAddFunctions = { {SAI, 'BuildOnce'}, },
        BuilderType = 'Any',
        BuilderData = {
            Enhancement = { 'AdvanceAntiair' },
        },
    },
}
